#!/usr/bin/perl -w

# gnupod-utils: utilities for GnuPod tunes database
# Copyright (C) 2002  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

use strict;
use iPod;
use Getopt::Std;

my %opt = ();
$opt{m} = $ENV{IPOD_MOUNTPOINT}; #defaulting
getopts('m:', \%opt);

die "Usage: $0 -m IPOD_MOUNTPOINT\n" if !$opt{m};
iPod::read_xml("$opt{m}/iPod_Control/.gnupod/GNUtunesDB");

my %renumber = ();

# renumber songs

my $n = 1;
for my $s (@{$iPod::songs}) {
    $renumber{$s->{id}} = $n;
    $s->{id} = $n;
    $n++;
}

# renumber playlist entries

for my $p (@{$iPod::playlists}) {
    for my $e (@{$p->{add}}) {
	my $old_id = $e->{id};
	next unless defined $old_id;
	my $new_id = $renumber{$old_id};
	unless (defined $new_id) {
	    my $name = $p->{name};
	    die "$0: non-existent entry $old_id in playlist '$name'\n";
	}
	$e->{id} = $new_id;
    }
}

iPod::write_xml();
